// SimpleViewer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "SimpleViewer.h"
#include "MainFrm.h"

#include "SimpleViewerDoc.h"
#include "SimpleViewerView.h"

// SceniX ---------------------- begin
#include "nvsg/nvsg.h"
#include "nvutil/Log.h"
#include <string>

// enable memory leak detection
#include "nvutil/DbgNew.h"
#include ".\simpleviewer.h"

// SceniX ---------------------- end

// CSimpleViewerApp

BEGIN_MESSAGE_MAP(CSimpleViewerApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()


// CSimpleViewerApp construction

CSimpleViewerApp::CSimpleViewerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CSimpleViewerApp object

CSimpleViewerApp theApp;

// CSimpleViewerApp initialization

BOOL CSimpleViewerApp::InitInstance()
{

// SceniX ---------------------- begin
  // one-time initialization of global data required by the SceniX API
  nvsg::nvsgInitialize();
// SceniX ---------------------- end

  // InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CSimpleViewerDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CSimpleViewerView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);
	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();
	return TRUE;
}

int CSimpleViewerApp::ExitInstance()
{
// SceniX ---------------------- begin
  // free global data required by the nvsg API
  nvsg::nvsgTerminate();
// SceniX ---------------------- end
  return CWinApp::ExitInstance();
}

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CSimpleViewerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CSimpleViewerApp message handlers

BOOL CSimpleViewerApp::OnIdle(LONG lCount)
{
  // SceniX ---------------------- begin
  BOOL retval  = CWinApp::OnIdle(lCount);
  CSimpleViewerView * pView = dynamic_cast<CSimpleViewerView *>(((CFrameWnd*)AfxGetMainWnd())->GetActiveView());
  if (pView)
  {
    retval |= pView->doIdleHandling();
  }

  return retval;
  // SceniX ---------------------- end
}
