// SimpleViewerDoc.h : interface of the CSimpleViewerDoc class
//
#pragma once

#include "nvsg/Scene.h"
#include "nvsg/ViewState.h"

using nvsg::Scene;
using nvsg::ViewState;

class nvsg::Node;
using nvsg::Node;

class CSimpleViewerDoc : public CDocument
{
 	DECLARE_DYNCREATE(CSimpleViewerDoc)

public:
	virtual ~CSimpleViewerDoc();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

  // Overrides
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
  virtual void DeleteContents();

  // SceniX ---------------------- begin
  nvsg::SceneHandle * getScene( void )      const { return( m_sceneHdl ); }
  // SceniX ---------------------- end

protected: 
  // create from serialization only
	CSimpleViewerDoc();

  // SceniX ---------------------- begin
  nvsg::SceneHandle * m_sceneHdl;     
  
  nvsg::NodeHandle * createSimpleTree() const;

  // SceniX ---------------------- begin

	DECLARE_MESSAGE_MAP()
};


