// SimpleViewerView.h : interface of the CSimpleViewerView class
//
#pragma once

#include "SilverLiningManager.h"

// forward declaration
class CSimpleViewerDoc;

// SceniX ---------------------- begin
namespace nvui
{
  class RenderArea;
  class TrackballCameraManipulator;
}
// SceniX ---------------------- end

class CSimpleViewerView : public CView
{
  DECLARE_DYNCREATE(CSimpleViewerView)
public:
  virtual ~CSimpleViewerView();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
  CSimpleViewerDoc* GetDocument() const;
  nvui::RenderArea * getRenderArea() const { return m_pRA; }
  BOOL doIdleHandling();
  
  // Overrides
 	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
  virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
  virtual void OnInitialUpdate();

  afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnDestroy();
  afx_msg BOOL OnEraseBkgnd(CDC* pDC);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
  afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
  afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnMButtonUp(UINT nFlags, CPoint point);
  afx_msg void OnMouseMove(UINT nFlags, CPoint point);
  afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnKillFocus(CWnd* pNewWnd);

protected: 
  // create from serialization only
	CSimpleViewerView(); 

  // Overrides
  virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);


  // SceniX ---------------------- begin
  nvui::RenderArea                 * m_pRA;  
  nvui::TrackballCameraManipulator * m_pCamManip;
 
  SilverLiningManager        *m_pSilverLiningManager;

  void setupRenderArea();
  void cleanupRenderArea();
  void setupAtmosphericConditions(SilverLining::Atmosphere * atmosphere);
  // SceniX ---------------------- end

  DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SimpleViewerView.cpp
inline CSimpleViewerDoc* CSimpleViewerView::GetDocument() const
{ 
  return reinterpret_cast<CSimpleViewerDoc*>(m_pDocument); 
}
#endif

